import { Component, Inject } from '@angular/core';
import { DataSvc } from "../services/DataScv";
import '@grapecity/wijmo.styles/wijmo.css';
import * as wjGrid from '@grapecity/wijmo.grid';
import * as wjCore from "@grapecity/wijmo";
import * as wjSheet from '@grapecity/wijmo.grid.sheet';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css']
})
export class AppComponent {
    public data: wjCore.CollectionView;

    constructor(@Inject(DataSvc) private _dataSvc: DataSvc) {
        this.data = new wjCore.CollectionView(this._dataSvc.getData(10));

    }
    initSheet(s: wjSheet.FlexSheet, e: wjCore.EventArgs) {
        let hostElem = document.createElement('div'),
            grid = new wjGrid.FlexGrid(hostElem, {
                itemsSource: this.data,
                columns: [
                    { binding: 'id', header: 'ID (Custom)' },
                    { binding: 'description', header: 'Description [Custom]', width: '*' },
                    { binding: 'country', width: '*' },
                    { binding: 'sales' },
                    { binding: 'downloads' }
                ]
            });

        grid.columns.forEach((c: any, i) => {
            c['columnModel'] = "colModel"
            c['formula'] = "(C,*E,)"
        })

        s.sheets.push(new wjSheet.Sheet(s, grid, 'Random Data'));
        s.hostElement.addEventListener('contextmenu', function (e) {
            e.preventDefault();
        }, true)
        
        var elem = document.querySelector('.wj-flexsheet-formula-list');
        elem?.parentNode?.removeChild(elem)
        
        // s.enableFormulas = false
    }
}
